#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>

//Your goal is to jump here to print the flag
void print_flag()
{
    printf("CTF{REDACTED}\n");
}

void print_url(char *host, char *path)
{
    char url[112];
    char low_path[48];
    char low_host[48];

    //Super safe program: verify we do not overflow
    if(strlen(host) > 48) {
        printf("Host is too long!\n");
        exit(1);
    }
    if(strlen(path) > 48) {
        printf("Path is too long!\n");
        exit(1);
    }

    //Convert host and path to lowercase
    strcpy(low_host, host); //low_host = host
    strcpy(low_path, path); //low_path = path
    for(int i=0; i<strlen(low_host); i++) low_host[i] = tolower(low_host[i]);
    for(int i=0; i<strlen(low_path); i++) low_path[i] = tolower(low_path[i]);

    //Print address of print_flag and the lowered-case host and path
    printf("print_flag @ %p\n", &print_flag);
    printf("host: %s\n", low_host);
    printf("path: %s\n", low_path);

    //save into url the full link. url = https://<low_host>/<low_path>
    sprintf(url, "https://%s/%s", low_host, low_path);

    printf("url=%s\n", url);
    //Hint: show where the print_url function will return
    printf("print_url has ended! Returning to %p\n", __builtin_return_address(0));
    return;
}

int main(int argc, char **argv)
{
    char host[100];
    char path[100];

    printf("---- URL BUILDER ----\n");

    printf("Host: ");
    fgets(host,100,stdin);

    printf("Path: ");
    fgets(path,100,stdin);

    // Remove any trailing newlines
    host[strcspn(host, "\n")] = 0;
    path[strcspn(path, "\n")] = 0;

    printf("--- Building URL ----\n");

    print_url(host, path);

    return 0;
}
